
import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;
import std.date;

long getCount()
{
  asm
  {
    naked;
    rdtsc;
    ret;
  }
}

// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// -------------------- main

void test1()
{
  int[] i;
  Box b;
  char *p=cast(char*)(&i);
  int k;
//  printf("%i\n",cell.sizeof); // -> 8
//  printf("%i\n",cell[].sizeof); // -> 8

  printf("(void[100]).sizeof=%i\n",(void[100]).sizeof);

  printf("int[].sizeof=%i\n",i.sizeof);
  i.length=3;
  for (k=0;k<i.sizeof;k++)
    printf("%02x ",*p++);
  printf("\n");

  printf("Box.sizeof=%i\n",b.sizeof);
  for (k=0;k<b.sizeof;k++)
    printf("%02x ",*p++);
  printf("\n");
}

void test2()
{
  printf("%i\n",["abc","d","ef"]==["abc","d","ef"]);
  printf("%i\n",["abc","d","ef"]==["abc","d","e"]);
  printf("%i\n",["abc","d","ef"]==["bc","d","ef"]);
  printf("%i\n",["abc","d","ef"]==["abc","ef"]);
  printf("%i\n",["abc","d","ef"]==["abc","d"]);
}

void init()
{
  types_init();
  register_prims();
}

void job()
{
  run();
  ds_show();
}

void main(char[][] args)
{
  long t;
  // initialise
  init();
  // load prelude
  src_push_file(r"prelude.g");
  job();
  // load source
  if (args.length>1)
    src_push_file(args[1]);
  else
    src_push_file(r"\coding\grace\test.g");
  // start timing
  printf("start\n");
  t=getCount();
  // interpreter main
  job();
  // show timing
  t=getCount()-t;
  printf("stop\n");
  printf("time:%.3f s\n",(cast(float)t)/1666e6);
  //
// test();
}
