
module grace_prim_disp;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prims_disp()
{
  // output
  dict_addnm("ids" ,&p_prds);
  dict_addnm("idss",&p_prdss);
  dict_addnf("ds"  ,&p_prds);
  dict_addnf("dss" ,&p_prdss);
//  dict_addnf("disp",&p_disp,["*"]);
  dict_addnf("pr"  ,&p_pr,["*"]);
  dict_addnf("cr"  ,&p_cr);
//  dict_addnf("dict",&p_dict);
}

static this()
{
  reg_prims~=&reg_prims_disp;
}
// --------------------
// ----- display

void p_cr()
{
  writef("\n");
//  fflush(stdout);
}

void p_pr_asa()
{
  cell[char[]] asa=dpop_asa();
  char[][] keys=asa.keys;
  cell[] vals=asa.values;
  writef("[ ");
  for (int k=0;k<keys.length;k++)
  {
    writef("\"",keys[k]);
    writef("\"->%s ",cell_vs(vals[k]));
  }
  writef("]\n");
//  fflush(stdout);
}

void p_pr()
{
//  writefln("pr{");
  switch (dtos().th)
  {
    case CT_ASA : p_pr_asa();break;
    case CT_STR : writef("%s",dpop_str());break;
    default     : writef("%s",cell_vs(dpop()));
  }
//  writefln("}pr");
//  fflush(stdout);
}

void p_prds()
{
  ds_show();
//  fflush(stdout);
}

void p_prdss()
{
  dss_show();
//  fflush(stdout);
}

void p_dict()
{
  dict_show();
//  fflush(stdout);
}

